]> git.pld-linux.org Git - packages/rpm.git/blobdiff - builder
- it uses bash syntax, maybe should be rewritten
[packages/rpm.git] / builder
diff --git a/builder b/builder
index da5643699544a2df84397fed8d06d6d0e705665b..d1bbfe252a8e0c8dd6173c5d1a683df9d3466eda 100644 (file)
--- a/builder
+++ b/builder
@@ -1,4 +1,8 @@
 #!/bin/ksh
+#
+# This program is free software, distributed under the terms of
+# the GNU General Public License Version 2.
+#
 # -----------
 # Exit codes:
 #        0 - succesful
 #       10 - Refused to build fractional release
 #      100 - Unknown error (should not happen)
 
-# Notes (todo):
-#      - builder -u fetches current version first (well that's okay, how you compare versions if you have no old spec?)
-#      - when Icon: field is present, -5 and -a5 doesn't work
-#      - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
+# Notes (todo/bugs):
+# - builder -u fetches current version first (well that's okay, how you compare versions if you have no old spec?)
+# - when Icon: field is present, -5 and -a5 doesn't work
+# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
+# TODO:
+# - ability to do ./builder -bb foo.spec foo2.spec foo3.spec
 
-RCSID='$Id$'
-r=${RCSID#* * }
-rev=${r%% *}
-VERSION="v0.18/$rev"
+VERSION="v0.22-RELEASE"
 VERSIONSTRING="\
 Build package utility from PLD Linux CVS repository
-$VERSION (C) 1999-2007 Free Penguins".
+$VERSION (C) 1999-2008 Free Penguins".
 
 PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
 
@@ -42,11 +45,16 @@ NOCVS=""
 NOCVSSPEC=""
 NODIST=""
 NOINIT=""
+PREFMIRRORS=""
 UPDATE=""
 ADD5=""
 NO5=""
 ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
 CVSROOT=""
+GREEDSRC=""
+
+# use rpm 4.4.6+ digest format instead of comments if non-zero
+USEDIGEST=
 
 # user agent when fetching files
 USER_AGENT="PLD/Builder($VERSION)"
@@ -66,7 +74,7 @@ LOGDIRFAIL=""
 LASTLOG_FILE=""
 
 CHMOD="no"
-CHMOD_MODE="0444"
+CHMOD_MODE="0644"
 RPMOPTS=""
 RPMBUILDOPTS=""
 BCOND=""
@@ -104,12 +112,19 @@ TRY_UPGRADE=""
 # should the specfile be restored if upgrade failed?
 REVERT_BROKEN_UPGRADE="yes"
 
-if [ -x /usr/bin/rpm-getdeps ]; then
-       FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
-else
+if rpm --specsrpm 2>/dev/null; then
+       FETCH_BUILD_REQUIRES_RPMSPECSRPM="yes"
        FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
+else
+       FETCH_BUILD_REQUIRES_RPMSPECSRPM="no"
+       if [ -x /usr/bin/rpm-getdeps ]; then
+               FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
+       else
+               FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
+       fi
 fi
 
+
 # Here we load saved user environment used to
 # predefine options set above, or passed to builder
 # in command line.
@@ -176,12 +191,19 @@ else
        RPMBUILD="rpmbuild"
 fi
 
-POLDEK_INDEX_DIR="`$RPM --eval %_rpmdir`/"
+#
+# are we using cvs-nserver ?
+#
+CVS_NSERVER=0
+cvs --version 2>&1 | grep -q 'CVS-nserver'
+[ $? -eq 0 ] && CVS_NSERVER=1
+
+POLDEK_INDEX_DIR="$($RPM --eval %_rpmdir)/"
 POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
 
 run_poldek()
 {
-       RES_FILE=~/tmp/poldek-exit-status.$RANDOM
+       RES_FILE=$(mktemp -t builder.XXXXXX || ${TMPDIR:-/tmp}/builder.$RANDOM)
        if [ -n "$LOGFILE" ]; then
                LOG=`eval echo $LOGFILE`
                if [ -n "$LASTLOG_FILE" ]; then
@@ -209,7 +231,7 @@ Usage: builder [-D|--debug] [-V|--version] [--short-version] [-a|--as_anon] [-b|
 [-g|--get] [-h|--help] [--http] [{-l|--logtofile} <logfile>] [-m|--mr-proper]
 [-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T|--tag <cvstag>]
 [-Tvs|--tag-version-stable] [-Ts|--tag-stable] [-Tv|--tag-version]
-[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}]
+[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}] [--use-greed-sources]
 [-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--short-circuit]
 [--show-bconds] [--with/--without <feature>] [--define <macro> <value>]
 <package>[.spec][:cvstag]
@@ -235,12 +257,17 @@ Usage: builder [-D|--debug] [-V|--version] [--short-version] [-a|--as_anon] [-b|
 --short-circuit     - short-circuit build
 -B, --branch        - add branch
 -c, --clean         - clean all temporarily created files (in BUILD, SOURCES,
-                      SPECS and \$RPM_BUILD_ROOT),
+                      SPECS and \$RPM_BUILD_ROOT and CVS/Entries) after rpmbuild commands.
+-m, --mr-proper     - clean all temporarily created files (in BUILD, SOURCES,
+                                         SPECS and \$RPM_BUILD_ROOT and CVS/Entries). Doesn't run
+                                         any rpm building.
 -cf, --cvs-force       - use -F when tagging (useful when moving branches)
 -d <cvsroot>, --cvsroot <cvsroot>
                     - setup \$CVSROOT,
 --define <macro> <value>
                     - define a macro <macro> with value <value>,
+--alt_kernel <kernel>
+                    - same as --define 'alt_kernel <kernel>'
 --nodeps            - rpm won't check any dependences
 -g, --get           - get <package>.spec and all related files from CVS repo
                       or HTTP/FTP,
@@ -248,8 +275,6 @@ Usage: builder [-D|--debug] [-V|--version] [--short-version] [-a|--as_anon] [-b|
 --http              - use http instead of ftp,
 -l <logfile>, --logtofile <logfile>
                     - log all to file,
--m, --mr-proper     - only remove all files related to spec file and all work
-                      resources,
 -nc, --no-cvs       - don't download sources from CVS, if source URL is given,
 -ncs, --no-cvs-specs
                     - don't check specs in CVS
@@ -259,6 +284,7 @@ Usage: builder [-D|--debug] [-V|--version] [--short-version] [-a|--as_anon] [-b|
 -ns, --no-srcs      - don't download Sources
 -ns0, --no-source0  - don't download Source0
 -nn, --no-net       - don't download anything from the net
+-pm, --prefer-mirrors - prefer mirrors (if any) over distfiles for SOURCES
 --no-init           - don't initialize builder paths (SPECS and SOURCES)
 -ske,
 --skip-existing-files - skip existing files in get_files
@@ -310,6 +336,9 @@ Usage: builder [-D|--debug] [-V|--version] [--short-version] [-a|--as_anon] [-b|
 -u, --try-upgrade   - check version, and try to upgrade package
 -un, --try-upgrade-with-float-version
                     - as above, but allow float version
+--use-greed-sources
+                    - try download source from tag head if don't find it in
+                      current tag
 -U, --update        - refetch sources, don't use distfiles, and update md5 comments
 -Upi, --update-poldek-indexes
                     - refresh or make poldek package index files.
@@ -331,6 +360,16 @@ Usage: builder [-D|--debug] [-V|--version] [--short-version] [-a|--as_anon] [-b|
 "
 }
 
+# change dependency to specname
+# common changes:
+# - perl(Package::Name) -> perl-Package-Name
+depspecname() {
+       local package="$1"
+
+       package=$(echo "$package" | sed -e '/perl(.*)/{s,perl(\(.*\)),perl-\1,;s,::,-,g}')
+       echo "$package"
+}
+
 update_shell_title() {
        [ -t 1 ] || return
        local len=${COLUMNS:-80}
@@ -349,7 +388,7 @@ update_shell_title() {
                fi
 
                msg="$pkg: ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
-               msg="$(echo $msg | tr -d '\n\r')"
+               msg=$(echo $msg | tr -d '\n\r')
                case "$TERM" in
                        cygwin|xterm*)
                        echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
@@ -383,7 +422,7 @@ minirpm() {
        # we reset macros not to contain macros.build as all the %() macros are
        # executed here, while none of them are actually needed.
        # at the time of this writing macros.build + macros contained 70 "%(...)" macros.
-       safe_macrofiles=$(rpm --showrc | awk -F: '/^macrofiles/ { gsub(/^macrofiles[ \t]+:/, "", $0); gsub(/:.*macros.build:/, ":", $0); print $0 } ')
+       safe_macrofiles=$(rpm $TARGET_SWITCH --showrc | awk -F: '/^macrofiles/ { gsub(/^macrofiles[ \t]+:/, "", $0); gsub(/:.*macros.build:/, ":", $0); print $0 } ')
 
        # TODO: move these to /usr/lib/rpm/macros
        cat > $BUILDER_MACROS <<'EOF'
@@ -408,6 +447,10 @@ minirpm() {
 %__php_api_requires() %{nil}
 %php_major_version ERROR
 %php_api_version ERROR
+%requires_xorg_xserver_extension %{nil}
+%requires_xorg_xserver_xinput %{nil}
+%requires_xorg_xserver_font %{nil}
+%requires_xorg_xserver_videodrv %{nil}
 %py_ver ERROR
 %perl_vendorarch ERROR
 %perl_vendorlib ERROR
@@ -424,6 +467,10 @@ minirpm() {
        rm -f %{tmpdir}/__ps{1,2};
 ) \
 %{nil}
+%add_etc_shells(p) %{p:<lua>}
+%remove_etc_shells(p) %{p:<lua>}
+%lua_add_etc_shells()  %{nil}
+%lua_remove_etc_shells() %{nil}
 EOF
        if [ "$NOINIT" = "yes" ] ; then
                cat >> $BUILDER_MACROS <<'EOF'
@@ -431,7 +478,7 @@ EOF
 %_sourcedir ./
 EOF
        fi
-       eval $RPMBUILD --macros "$safe_macrofiles:$BUILDER_MACROS" $QUIET $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $* 2>&1
+       eval $RPMBUILD $TARGET_SWITCH --macros "$safe_macrofiles:$BUILDER_MACROS" $QUIET $RPMOPTS $RPMBUILDOPTS $BCOND $* 2>&1
 }
 
 cache_rpm_dump() {
@@ -440,41 +487,46 @@ cache_rpm_dump() {
                set -v
        fi
 
-       update_shell_title "cache_rpm_dump"
-       local rpm_dump
-       rpm_dump=`
-               # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
-               dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
-               case "$RPMBUILD" in
-               rpm)
-                       ARGS='-bp'
-                       ;;
-               rpmbuild)
-                       ARGS='--nodigest --nosignature --nobuild'
-                       ;;
-               esac
-               minirpm $ARGS --define "'prep $dump'" --nodeps $SPECFILE
-       `
-       if [ $? -gt 0 ]; then
-               error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
-               echo "$error" >&2
-               Exit_error err_build_fail
-       fi
+       if [ -x /usr/bin/rpm-specdump ]; then
+               update_shell_title "cache_rpm_dump using rpm-specdump command"
+               rpm_dump_cache=$(rpm-specdump $TARGET_SWITCH $BCOND $SPECFILE)
+       else
+               update_shell_title "cache_rpm_dump using rpmbuild command"
+               local rpm_dump
+               rpm_dump=`
+                       # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
+                       dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
+                       case "$RPMBUILD" in
+                       rpm)
+                               ARGS='-bp'
+                               ;;
+                       rpmbuild)
+                               ARGS='--nodigest --nosignature --nobuild'
+                               ;;
+                       esac
+                       minirpm $ARGS --define "'prep $dump'" --nodeps $SPECFILE
+               `
+               if [ $? -gt 0 ]; then
+                       error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
+                       echo "$error" >&2
+                       Exit_error err_build_fail
+               fi
 
-       # make small dump cache
-       rpm_dump_cache=`echo "$rpm_dump" | awk '
-               $2 ~ /^SOURCEURL/ {print}
-               $2 ~ /^PATCHURL/  {print}
-               $2 ~ /^nosource/ {print}
-               $2 ~ /^PACKAGE_/ {print}
-       '`
+               # make small dump cache
+               rpm_dump_cache=`echo "$rpm_dump" | awk '
+                       $2 ~ /^SOURCEURL/ {print}
+                       $2 ~ /^PATCHURL/  {print}
+                       $2 ~ /^nosource/ {print}
+                       $2 ~ /^PACKAGE_/ {print}
+               '`
+       fi
 
        update_shell_title "cache_rpm_dump: OK!"
 }
 
 rpm_dump() {
        if [ -z "$rpm_dump_cache" ] ; then
-               echo "internal error: cache_rpm_dump not called! (missing %prep?)" 1>&2
+               echo >&2 "internal error: cache_rpm_dump not called! (missing %prep?)"
        fi
        echo "$rpm_dump_cache"
 }
@@ -482,7 +534,7 @@ rpm_dump() {
 get_icons()
 {
        update_shell_title "get icons"
-       ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
+       ICONS=$(awk '/^Icon:/ {print $2}' ${SPECFILE})
        if [ -z "$ICONS" ]; then
                return
        fi
@@ -501,25 +553,25 @@ parse_spec()
        # icons are needed for successful spec parse
        get_icons
 
-       cd $SPECS_DIR
+       cd $SPEC_DIR
        cache_rpm_dump
 
        if [ "$NOSRCS" != "yes" ]; then
-               SOURCES="`rpm_dump | awk '/SOURCEURL[0-9]+/ {print $3}'`"
+               SOURCES=$(rpm_dump | awk '/SOURCEURL[0-9]+/ {print $3}')
        fi
 
        if (rpm_dump | grep -qEi ":.*nosource.*1"); then
                FAIL_IF_NO_SOURCES="no"
        fi
 
-       PATCHES="`rpm_dump | awk '/PATCHURL[0-9]+/ {print $3}'`"
-       ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
+       PATCHES=$(rpm_dump | awk '/PATCHURL[0-9]+/ {print $3}')
+       ICONS=$(awk '/^Icon:/ {print $2}' ${SPECFILE})
        PACKAGE_NAME=$(rpm_dump | awk '$2 == "PACKAGE_NAME" { print $3; exit}')
        PACKAGE_VERSION=$(rpm_dump | awk '$2 == "PACKAGE_VERSION" { print $3; exit}')
        PACKAGE_RELEASE=$(rpm_dump | awk '$2 == "PACKAGE_RELEASE" { print $3; exit}')
 
        if [ "$PACKAGE_NAME" != "$ASSUMED_NAME" ]; then
-               echo "WARNING! Spec name ($ASSUMED_NAME) does not agree with package name ($PACKAGE_NAME)"
+               echo >&2 "WARNING! Spec name ($ASSUMED_NAME) does not agree with package name ($PACKAGE_NAME)"
        fi
 
        if [ -n "$BE_VERBOSE" ]; then
@@ -554,45 +606,45 @@ Exit_error()
        case "$1" in
                "err_no_spec_in_cmdl" )
                        remove_build_requires
-                       echo "ERROR: spec file name not specified."
+                       echo >&2 "ERROR: spec file name not specified."
                        exit 2 ;;
                "err_invalid_cmdline" )
-                       echo "ERROR: invalid command line arg ($2)."
+                       echo >&2 "ERROR: invalid command line arg ($2)."
                        exit 2 ;;
                "err_no_spec_in_repo" )
                        remove_build_requires
-                       echo "Error: spec file not stored in CVS repo."
+                       echo >&2 "Error: spec file not stored in CVS repo."
                        exit 3 ;;
                "err_no_source_in_repo" )
                        remove_build_requires
-                       echo "Error: some source, patch or icon files not stored in CVS repo. ($2)"
+                       echo >&2 "Error: some source, patch or icon files not stored in CVS repo. ($2)"
                        exit 4 ;;
                "err_build_fail" )
                        remove_build_requires
-                       echo "Error: package build failed. (${2:-no more info})"
+                       echo >&2 "Error: package build failed. (${2:-no more info})"
                        exit 5 ;;
                "err_no_package_data" )
                        remove_build_requires
-                       echo "Error: couldn't get out package name/version/release from spec file."
+                       echo >&2 "Error: couldn't get out package name/version/release from spec file."
                        exit 6 ;;
                "err_tag_exists" )
                        remove_build_requires
-                       echo "Tag ${2} already exists (spec release: ${3})."
+                       echo >&2 "Tag ${2} already exists (spec release: ${3})."
                        exit 9 ;;
                "err_fract_rel" )
                        remove_build_requires
-                       echo "Release ${2} not integer and not a snapshot."
+                       echo >&2 "Release ${2} not integer and not a snapshot."
                        exit 10 ;;
                "err_branch_exists" )
                        remove_build_requires
-                       echo "Tree branch already exists (${2})."
+                       echo >&2 "Tree branch already exists (${2})."
                        exit 11 ;;
                "err_acl_deny" )
                        remove_build_requires
-                       echo "Error: conditions reject building this spec (${2})."
+                       echo >&2 "Error: conditions reject building this spec (${2})."
                        exit 12 ;;
        esac
-       echo "Unknown error."
+       echo >&2 "Unknown error."
        exit 100
 }
 
@@ -604,14 +656,18 @@ init_builder()
        fi
 
        if [ "$NOINIT" != "yes" ] ; then
-               SOURCE_DIR="`eval $RPM $RPMOPTS --define '"name $ASSUMED_NAME"' --eval '%{_sourcedir}'`"
-               SPECS_DIR="`eval $RPM $RPMOPTS --define '"name $ASSUMED_NAME"' --eval '%{_specdir}'`"
+               local extra
+               if [ "$ASSUMED_NAME" ]; then
+                       extra="--define 'name $ASSUMED_NAME'"
+               fi
+               SOURCE_DIR=$(eval $RPM $RPMOPTS $extra --eval '%{_sourcedir}')
+               SPEC_DIR=$(eval $RPM $RPMOPTS $extra --eval '%{_specdir}')
        else
                SOURCE_DIR="."
-               SPECS_DIR="."
+               SPEC_DIR="."
        fi
 
-       __PWD="`pwd`"
+       __PWD=$(pwd)
 }
 
 get_spec()
@@ -624,9 +680,9 @@ get_spec()
                set -v
        fi
 
-       cd "$SPECS_DIR"
+       cd "$SPEC_DIR"
        if [ ! -f "$SPECFILE" ]; then
-               SPECFILE="`basename $SPECFILE .spec`.spec"
+               SPECFILE="$(basename $SPECFILE .spec).spec"
        fi
        if [ "$NOCVSSPEC" != "yes" ]; then
 
@@ -653,7 +709,7 @@ get_spec()
 
 find_mirror()
 {
-       cd "$SPECS_DIR"
+       cd "$SPEC_DIR"
        local url="$1"
        if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
                cvs update mirrors >&2
@@ -666,10 +722,10 @@ find_mirror()
                if [ -z "$origin" ] || [[ $origin == \#* ]]; then
                        continue
                fi
-               ol=`echo -n "$origin"|wc -c`
-               prefix="`echo -n "$url" | head -c $ol`"
+               ol=$(echo -n "$origin" | wc -c)
+               prefix=$(echo -n "$url" | head -c $ol)
                if [ "$prefix" = "$origin" ] ; then
-                       suffix="`echo "$url"|cut -b $((ol+1))-`"
+                       suffix=$(echo "$url" | cut -b $((ol+1))-)
                        echo -n "$mirror$suffix"
                        return 0
                fi
@@ -680,7 +736,7 @@ find_mirror()
 # Warning: unpredictable results if same URL used twice
 src_no ()
 {
-       cd $SPECS_DIR
+       cd $SPEC_DIR
        rpm_dump | \
        grep "SOURCEURL[0-9]*[  ]*$1""[         ]*$" | \
        sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
@@ -692,13 +748,13 @@ src_md5()
        [ "$NO5" = "yes" ] && return
        no=$(src_no "$1")
        [ -z "$no" ] && return
-       cd $SPECS_DIR
+       cd $SPEC_DIR
        local md5
 
        if [ -f additional-md5sums ]; then
                local spec_rev=$(grep $SPECFILE CVS/Entries 2>/dev/null | sed -e s:/$SPECFILE/:: -e s:/.*::)
                if [ -z "$spec_rev" ]; then
-                       spec_rev="$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')"
+                       spec_rev=$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')
                fi
                local spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
                md5=$(grep -s -v '^#' additional-md5sums | \
@@ -719,11 +775,16 @@ src_md5()
        if [ -n "$source_md5" ]; then
                echo $source_md5
        else
-               # we have empty SourceX-md5, but it is still possible
-               # that we have NoSourceX-md5 AND NoSource: X
-               nosource_md5=`grep -i "#[        ]*NoSource$no-md5[      ]*:" $SPECFILE | sed -e 's/.*://'`
-               if [ -n "$nosource_md5" -a -n "`grep -i "^NoSource:[     ]*$no$" $SPECFILE`" ] ; then
-                       echo $nosource_md5
+               source_md5=`grep -i "BuildRequires:[    ]*digest(%SOURCE$no)[   ]*=" $SPECFILE | sed -e 's/.*=//'`
+               if [ -n "$source_md5" ]; then
+                       echo $source_md5
+               else
+                       # we have empty SourceX-md5, but it is still possible
+                       # that we have NoSourceX-md5 AND NoSource: X
+                       nosource_md5=`grep -i "#[        ]*NoSource$no-md5[      ]*:" $SPECFILE | sed -e 's/.*://'`
+                       if [ -n "$nosource_md5" -a -n "`grep -i "^NoSource:[     ]*$no$" $SPECFILE`" ] ; then
+                               echo $nosource_md5
+                       fi
                fi
        fi
 }
@@ -752,7 +813,7 @@ good_md5 ()
 
 good_size ()
 {
-       size="$(find $(nourl "$1") -printf "%s" 2>/dev/null)"
+       size=$(find $(nourl "$1") -printf "%s" 2>/dev/null)
        [ -n "$size" -a "$size" -gt 0 ]
 }
 
@@ -844,9 +905,10 @@ update_md5()
                local srcno=$(src_no "$i")
                if [ -n "$ADD5" ]; then
                        [ "$fp" = "$i" ] && continue # FIXME what is this check doing?
-                       grep -qiE '^#[  ]*Source'$srcno'-md5[   ]*:' $SPECS_DIR/$SPECFILE && continue
+                       grep -qiE '^#[  ]*Source'$srcno'-md5[   ]*:' $SPEC_DIR/$SPECFILE && continue
+                       grep -qiE '^BuildRequires:[     ]*digest[(]%SOURCE'$srcno'[)][  ]*=' $SPEC_DIR/$SPECFILE && continue
                else
-                       grep -qiE '^#[  ]*Source'$srcno'-md5[   ]*:' $SPECS_DIR/$SPECFILE || continue
+                       grep -qiE '^#[  ]*Source'$srcno'-md5[   ]*:' $SPEC_DIR/$SPECFILE || grep -qiE '^BuildRequires:[         ]*digest[(]%SOURCE'$srcno'[)][  ]*=' $SPEC_DIR/$SPECFILE || continue
                fi
                if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
                        need_files="$need_files $i"
@@ -862,25 +924,32 @@ update_md5()
        for i in "$@"; do
                local fp=$(nourl "$i")
                local srcno=$(src_no "$i")
-               local md5=$(grep -iE '^#[       ]*(No)?Source'$srcno'-md5[      ]*:' $SPECS_DIR/$SPECFILE )
+               local md5=$(grep -iE '^#[       ]*(No)?Source'$srcno'-md5[      ]*:' $SPEC_DIR/$SPECFILE )
+               if [ -z "$md5" ]; then
+                       md5=$(grep -iE '^[      ]*BuildRequires:[       ]*digest[(]%SOURCE'$srcno'[)][  ]*=' $SPEC_DIR/$SPECFILE )
+               fi
                if [ -n "$ADD5" ] && is_url $i || [ -n "$md5" ]; then
-                       local tag="Source$srcno-md5"
+                       local tag="# Source$srcno-md5:\t"
                        if [[ "$md5" == *NoSource* ]]; then
-                               tag="NoSource$srcno-md5"
+                               tag="# NoSource$srcno-md5:\t"
+                       elif [ -n "$USEDIGEST" ]; then
+                               tag="BuildRequires:\tdigest(%SOURCE$srcno) = "
                        fi
                        md5=$(md5sum "$fp" | cut -f1 -d' ')
-                       echo "Updating $tag ($md5: $fp)."
+                       echo "Updating Source$srcno ($md5: $fp)."
                        perl -i -ne '
-                               print unless /^\s*#\s*(No)?Source'$srcno'-md5\s*:/i;
-                               print "# '$tag':\t'$md5'\n" if /^Source'$srcno'\s*:\s+/;
+                               print unless (/^\s*#\s*(No)?Source'$srcno'-md5\s*:/i or /^\s*BuildRequires:\s*digest\(%SOURCE'$srcno'\)/i);
+                               print "'"$tag$md5"'\n" if /^Source'$srcno'\s*:\s+/;
                        ' \
-                       $SPECS_DIR/$SPECFILE
+                       $SPEC_DIR/$SPECFILE
                fi
        done
 }
 
 check_md5()
 {
+       [ "$NO5" = "yes" ] && return
+
        update_shell_title "check md5"
 
        for i in "$@"; do
@@ -943,9 +1012,9 @@ get_files()
                                        fi
                                        target="$fp"
 
-                                       # prefer mirror over distfiles if there's mirror
+                                       # optionally prefer mirror over distfiles if there's mirror
                                        # TODO: build url list and then try each url from the list
-                                       if [ -z "$NOMIRRORS" ] && im=$(find_mirror "$i") && [ "$im" != "$i" ]; then
+                                       if [ -n "$PREFMIRRORS" ] && [ -z "$NOMIRRORS" ] && im=$(find_mirror "$i") && [ "$im" != "$i" ]; then
                                                url="$im"
                                        else
                                                url=$(distfiles_url "$i")
@@ -985,7 +1054,7 @@ get_files()
                                                        ${GETLOCAL} $url_attic $target
                                                else
                                                        if [ -z "$NOMIRRORS" ]; then
-                                                               url_attic="`find_mirror "$url_attic"`"
+                                                               url_attic=$(find_mirror "$url_attic")
                                                        fi
                                                        update_shell_title "${GETURI%% *}: $url_attic"
                                                        ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
@@ -1014,7 +1083,7 @@ get_files()
 
                                if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
                                        if [ -z "$NOMIRRORS" ]; then
-                                               im="`find_mirror "$i"`"
+                                               im=$(find_mirror "$i")
                                        else
                                                im="$i"
                                        fi
@@ -1034,7 +1103,11 @@ get_files()
 
                        # the md5 check must be moved elsewhere as if we've called from update_md5 the md5 is wrong.
                        if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
-                               Exit_error err_no_source_in_repo $i
+                               if [ -n "GREEDSRC" ]; then
+                                       get_greed_sources $i
+                               else
+                                       Exit_error err_no_source_in_repo $i
+                               fi
                        fi
 
                        # we check md5 here just only to refetch immediately
@@ -1071,7 +1144,7 @@ get_files()
                fi
 
                if [ "$CHMOD" = "yes" ]; then
-                       CHMOD_FILES="`nourl "$@"`"
+                       CHMOD_FILES=$(nourl "$@")
                        if [ -n "$CHMOD_FILES" ]; then
                                chmod $CHMOD_MODE $CHMOD_FILES
                        fi
@@ -1104,6 +1177,26 @@ make_tagver() {
        echo -n "$TAGVER"
 }
 
+# bool is_tag_a_branch(tag)
+#
+# returns 1 if a tag is a branch set on SPECFILE
+is_tag_a_branch() {
+       if [ -n "$DEBUG" ]; then
+               set -x
+               set -v
+       fi
+
+       if [ $# -ne 1 ]; then
+               return 0;
+       fi
+
+       TAG=$1
+
+       cd "$SPEC_DIR"
+       cvs status -v $SPECFILE | grep -Eiq "${TAG}.+(branch: [0-9.]+)"
+       return $?
+}
+
 tag_files()
 {
        TAG_FILES="$@"
@@ -1130,6 +1223,18 @@ tag_files()
                OPTIONS="-d $CVSROOT $OPTIONS"
        fi
 
+       # if a tagname we are about to set already exists
+       # and happens to be a branch (common case with AC-branch)
+       # pass -B (allows -F to disturb branch tag)
+       local _tag=$TAG
+       if [ "$TAG_VERSION" = "yes" ]; then
+               _tag=$TAGVER
+       fi;
+       is_tag_a_branch $_tag
+       if [ $? -eq 0 -a $CVS_NSERVER -eq 0 ]; then
+               OPTIONS="$OPTIONS -B"
+       fi;
+
        cd "$SOURCE_DIR"
        local tag_files
        for i in $TAG_FILES; do
@@ -1138,6 +1243,8 @@ tag_files()
                local fp=`nourl "$i"`
                if [ -f "$fp" ]; then
                        tag_files="$tag_files $fp"
+               elif [ -n "GREEDSRC" ]; then
+                       get_greed_sources $i
                else
                        Exit_error err_no_source_in_repo $i
                fi
@@ -1146,15 +1253,22 @@ tag_files()
        if [ "$tag_files" ]; then
                if [ "$TAG_VERSION" = "yes" ]; then
                        update_shell_title "tag sources: $TAGVER"
+                       printf "Tagging %d files\n" $(echo $tag_files | wc -w)
                        cvs $OPTIONS $TAGVER $tag_files || exit
                fi
                if [ -n "$TAG" ]; then
                        update_shell_title "tag sources: $TAG"
-                       cvs $OPTIONS $TAG $tag_files || exit
+
+                       while [ "$tag_files" ]; do
+                               local chunk=$(echo $tag_files | tr ' ' '\n' | head -n 100)
+                               printf "Tagging %d files\n" $(echo $chunk | wc -w)
+                               cvs $OPTIONS $TAG $chunk || exit
+                               tag_files=$(echo $tag_files | tr ' ' '\n' | tail +101)
+                       done
                fi
        fi
 
-       cd "$SPECS_DIR"
+       cd "$SPEC_DIR"
        if [ "$TAG_VERSION" = "yes" ]; then
                update_shell_title "tag spec: $TAGVER"
                cvs $OPTIONS $TAGVER $SPECFILE || exit
@@ -1179,6 +1293,13 @@ branch_files()
        fi
 
        local OPTIONS="tag $CVS_FORCE -b"
+
+       # branch exists?
+       is_tag_a_branch $TAG
+       if [ $? -eq 1 ]; then
+               OPTIONS="$OPTIONS -B"
+       fi
+
        if [ -n "$CVSROOT" ]; then
                OPTIONS="-d $CVSROOT $OPTIONS"
        fi
@@ -1188,6 +1309,8 @@ branch_files()
                local fp=`nourl "$i"`
                if [ -f "$fp" ]; then
                        tag_files="$tag_files $fp"
+               elif [ -n "GREEDSRC" ]; then
+                       get_greed_sources $i
                else
                        Exit_error err_no_source_in_repo $i
                fi
@@ -1196,7 +1319,7 @@ branch_files()
                cvs $OPTIONS $TAG $tag_files || exit
        fi
 
-       cd "$SPECS_DIR"
+       cd "$SPEC_DIR"
        cvs $OPTIONS $TAG $SPECFILE || exit
 }
 
@@ -1222,17 +1345,17 @@ build_package()
                set -v
        fi
 
-       cd "$SPECS_DIR"
+       cd "$SPEC_DIR"
 
        if [ -n "$TRY_UPGRADE" ]; then
                update_shell_title "build_package: try_upgrade"
                if [ -n "$FLOAT_VERSION" ]; then
-                       TNOTIFY=`./pldnotify.awk $SPECFILE -n` || exit 1
+                       TNOTIFY=$(./pldnotify.awk $SPECFILE -n) || exit 1
                else
-                       TNOTIFY=`./pldnotify.awk $SPECFILE` || exit 1
+                       TNOTIFY=$(./pldnotify.awk $SPECFILE) || exit 1
                fi
 
-               TNEWVER=`echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }'`
+               TNEWVER=$(echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }')
 
                if [ -n "$TNEWVER" ]; then
                        TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
@@ -1250,7 +1373,7 @@ build_package()
                        unset TOLDVER TNEWVER TNOTIFY
                fi
        fi
-       cd "$SPECS_DIR"
+       cd "$SPEC_DIR"
 
        case "$COMMAND" in
                build )
@@ -1281,8 +1404,9 @@ build_package()
                if [ -n "$LASTLOG_FILE" ]; then
                        echo "LASTLOG=$LOG" > $LASTLOG_FILE
                fi
-               RES_FILE=~/tmp/$RPMBUILD-exit-status.$RANDOM
-               (time eval ${NICE_COMMAND} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
+               RES_FILE=$(mktemp -t builder.XXXXXX || ${TMPDIR:-/tmp}/builder.$RANDOM)
+
+               (time eval ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
                RETVAL=`cat $RES_FILE`
                rm $RES_FILE
                if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
@@ -1293,7 +1417,7 @@ build_package()
                        fi
                fi
        else
-               eval ${NICE_COMMAND} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $SPECFILE
+               eval ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $SPECFILE
                RETVAL=$?
        fi
        if [ "$RETVAL" -ne "0" ]; then
@@ -1322,7 +1446,6 @@ install_required_packages()
 find_spec_bcond() {
        # taken from find-spec-bcond, but with just getting the list
        local SPEC="$1"
-       # quick revert hint: '$RPMBUILD --bcond $SPEC'
        awk -F"\n" '
        /^%changelog/ { exit }
        /_with(out)?_[_a-zA-Z0-9]+/{
@@ -1499,17 +1622,17 @@ run_sub_builder()
        #
        #
        # y0shi.
+       # kurwa. translate that ^^^^
 
        parent_spec_name=''
 
        # Istnieje taki spec? ${package}.spec
-       if [ -f "${SPECS_DIR}/${package}.spec" ]; then
+       if [ -f "${SPEC_DIR}/${package}.spec" ]; then
                parent_spec_name=${package}.spec
-       elif [ -f "${SPECS_DIR}/`echo ${package_name} | sed -e s,-devel.*,,g -e s,-static,,g`.spec" ]; then
-               parent_spec_name="`echo ${package_name} | sed -e s,-devel.*,,g -e s,-static,,g`.spec"
+       elif [ -f "${SPEC_DIR}/$(echo ${package_name} | sed -e s,-devel.*,,g -e s,-static,,g).spec" ]; then
+               parent_spec_name="$(echo ${package_name} | sed -e s,-devel.*,,g -e s,-static,,g).spec"
        else
-               for provides_line in `grep ^Provides:.*$package  ${SPECS_DIR} -R`
-               do
+               for provides_line in $(grep -r ^Provides:.*$package ${SPEC_DIR}); do
                        echo $provides_line
                done
        fi
@@ -1538,7 +1661,7 @@ spawn_sub_builder()
                sub_builder_opts="${sub_builder_opts} -Upi"
        fi
 
-       cd "${SPECS_DIR}"
+       cd "${SPEC_DIR}"
        ./builder ${sub_builder_opts} "$@"
 }
 
@@ -1555,7 +1678,7 @@ remove_build_requires()
                        *)
                                echo You may want to manually remove following BuildRequires fetched:
                                echo $INSTALLED_PACKAGES
-                               echo Try poldek -e \`cat `pwd`/.${SPECFILE}_INSTALLED_PACKAGES\`
+                               echo "Try poldek -e \`cat $(pwd)/.${SPECFILE}_INSTALLED_PACKAGES\`"
                                ;;
                esac
        fi
@@ -1584,19 +1707,19 @@ display_branches()
 }
 
 # checks a given list of packages/files/provides agains current rpmdb.
-# outputs all dependencies whcih current rpmdb doesn't satisfy.
+# outputs all dependencies which current rpmdb doesn't satisfy.
 # input can be either STDIN or parameters
 _rpm_prov_check()
 {
        local DEPS
 
-       if [ "$#" -gt 0 ]; then
+       if [ $# -gt 0 ]; then
                DEPS="$@"
        else
                DEPS=$(cat)
        fi
 
-       DEPS=$(rpm -q --whatprovides $DEPS 2>&1 | awk '/^(error:|no package provides)/ { print }')
+       DEPS=$(LANG=C rpm -q --whatprovides $DEPS 2>&1 | awk '/^(error:|no package provides)/ { print }')
 
        # packages
        echo "$DEPS" | awk '/^no package provides/ { print $NF }'
@@ -1606,74 +1729,88 @@ _rpm_prov_check()
 }
 
 # checks if given package/files/provides exists in rpmdb.
-# inout can be either stdin or parameters
-# returns packages wchi hare present in the rpmdb
+# input can be either stdin or parameters
+# returns packages which are present in the rpmdb
 _rpm_cnfl_check()
 {
        local DEPS
 
-       if [ "$#" -gt 0 ]; then
+       if [ $# -gt 0 ]; then
                DEPS="$@"
        else
                DEPS=$(cat)
        fi
 
-       rpm -q --whatprovides $DEPS 2>/dev/null | awk '!/no package provides/ { print }'
+       LANG=C rpm -q --whatprovides $DEPS 2>/dev/null | awk '!/no package provides/ { print }'
+}
+
+# install deps via information from 'rpm-getdeps' or 'rpm --specsrpm'
+install_build_requires_rpmdeps() {
+       if [ "$FETCH_BUILD_REQUIRES_RPMGETDEPS" = "yes" ]; then
+               # TODO: Conflicts list doesn't check versions
+               local CNFL=$(rpm-getdeps $BCOND $SPECFILE 2> /dev/null | awk '/^\-/ { print $3 } ' | _rpm_cnfl_check | xargs)
+               local DEPS=$(rpm-getdeps $BCOND $SPECFILE 2> /dev/null | awk '/^\+/ { print $3 } ' | _rpm_prov_check | xargs)
+       fi
+       if [ "$FETCH_BUILD_REQUIRES_RPMSPECSRPM" = "yes" ]; then
+               local CNFL=$(rpm -q --specsrpm --conflicts $BCOND $SPECFILE | awk '{print $1}' | _rpm_cnfl_check | xargs)
+               local DEPS=$(rpm -q --specsrpm --requires $BCOND $SPECFILE | awk '{print $1}' | _rpm_prov_check | xargs)
+       fi
+
+       if [ -n "$CNFL" ] || [ -n "$DEPS" ]; then
+               echo "fetch BuildRequires: install [$DEPS]; remove [$CNFL]"
+               update_shell_title "poldek: install [$DEPS]; remove [$CNFL]"
+               $SU_SUDO /usr/bin/poldek -q --update || $SU_SUDO /usr/bin/poldek -q --upa
+       fi
+       if [ -n "$CNFL" ]; then
+               update_shell_title "uninstall conflicting packages: $CNFL"
+               echo "Trying to uninstall conflicting packages ($CNFL):"
+               $SU_SUDO /usr/bin/poldek --noask --nofollow -ev $CNFL
+       fi
+
+       while [ "$DEPS" ]; do
+                       update_shell_title "install deps: $DEPS"
+                       echo "Trying to install dependencies ($DEPS):"
+                       local log=.${SPECFILE}_poldek.log
+                       LANG=C $SU_SUDO /usr/bin/poldek --caplookup -uGqQ $DEPS | tee $log
+                       failed=$(awk '/^error:/{a=$2; sub(/^error: /, "", a); sub(/:$/, "", a); print a}' $log)
+                       rm -f $log
+                       local ok
+                       if [ -n "$failed" ]; then
+                               for package in $failed; do
+                                       spawn_sub_builder -bb $(depspecname $package) && ok="$ok $package"
+                               done
+                               DEPS="$ok"
+                       else
+                               DEPS=""
+                       fi
+       done
 }
 
 fetch_build_requires()
 {
-       if [ "${FETCH_BUILD_REQUIRES}" = "yes" ]; then
-               update_shell_title "fetch build requires"
-               if [ "$FETCH_BUILD_REQUIRES_RPMGETDEPS" = "yes" ]; then
-                       # TODO: Conflicts list doesn't check versions
-                       local CNFL=$(rpm-getdeps $BCOND $SPECFILE 2> /dev/null | awk '/^\-/ { print $3 } ' | _rpm_cnfl_check | xargs)
-                       local DEPS=$(rpm-getdeps $BCOND $SPECFILE 2> /dev/null | awk '/^\+/ { print $3 } ' | _rpm_prov_check | xargs)
-
-                       if [ -n "$CNFL" ] || [ -n "$DEPS" ]; then
-                               echo "fetch builderequires: install $DEPS; remove $CNFL"
-                               update_shell_title "poldek: install $DEPS; remove $CNFL"
-                               $SU_SUDO /usr/bin/poldek -q --update || $SU_SUDO /usr/bin/poldek -q --upa
-                       fi
-                       if [ -n "$CNFL" ]; then
-                               update_shell_title "uninstall conflicting packages: $CNFL"
-                               echo "Trying to uninstall conflicting packages ($CNFL):"
-                               $SU_SUDO /usr/bin/poldek --noask --nofollow -ev $CNFL
-                       fi
+       if [ "${FETCH_BUILD_REQUIRES}" != "yes" ]; then
+               return
+       fi
 
-                       while [ "$DEPS" ]; do
-                                       update_shell_title "install deps: $DEPS"
-                                       echo "Trying to install dependencies ($DEPS):"
-                                       local log=.${SPECFILE}_poldek.log
-                                       $SU_SUDO /usr/bin/poldek --caplookup -uGq $DEPS | tee $log
-                                       failed=$(awk -F: '/^error:/{print $2}' $log)
-                                       rm -f $log
-                                       local ok
-                                       if [ -n "$failed" ]; then
-                                               for package in $failed; do
-                                                       # FIXME: sanitise, deps could be not .spec files
-                                                       spawn_sub_builder -bb $package && ok="$ok $package"
-                                               done
-                                               DEPS="$ok"
-                                       else
-                                               DEPS=""
-                                       fi
-                       done
-                       return
-               fi
+       update_shell_title "fetch build requires"
+       if [ "$FETCH_BUILD_REQUIRES_RPMGETDEPS" = "yes" ] || [ "$FETCH_BUILD_REQUIRES_RPMSPECSRPM" = "yes" ]; then
+               install_build_requires_rpmdeps
+               return
+       fi
 
+               # XXX is this ugliest code written in human history still needed?
                echo -ne "\nAll packages installed by fetch_build_requires() are written to:\n"
                echo -ne "`pwd`/.${SPECFILE}_INSTALLED_PACKAGES\n"
                echo -ne "\nIf anything fails, you may get rid of them by executing:\n"
                echo "poldek -e \`cat `pwd`/.${SPECFILE}_INSTALLED_PACKAGES\`\n\n"
                echo > `pwd`/.${SPECFILE}_INSTALLED_PACKAGES
-               for package_item in `cat $SPECFILE|grep -B100000 ^%changelog|grep -v ^#|grep BuildRequires|grep -v ^-|sed -e "s/^.*BuildRequires://g"|awk '{print $1}'|sed -e s,perl\(,perl-,g -e s,::,-,g -e s,\(.*\),,g -e s,%{,,g -e s,},,g|grep -v OpenGL-devel|sed -e s,sh-utils,coreutils,g -e s,fileutils,coreutils,g -e s,textutils,coreutils,g -e s,kgcc_package,gcc,g -e s,\),,g`
+               for package_item in $(cat $SPECFILE | grep -B100000 ^%changelog|grep -v ^#|grep BuildRequires|grep -v ^-|sed -e "s/^.*BuildRequires://g"|awk '{print $1}'|sed -e s,perl\(,perl-,g -e s,::,-,g -e s,\(.*\),,g -e s,%{,,g -e s,},,g|grep -v OpenGL-devel|sed -e s,sh-utils,coreutils,g -e s,fileutils,coreutils,g -e s,textutils,coreutils,g -e s,kgcc_package,gcc,g -e s,\),,g)
                do
-                       package_item="`echo $package_item|sed -e s,rpmbuild,rpm-build,g |sed -e s,__perl,perl,g |sed -e s,gasp,binutils-gasp,g -e s,binutils-binutils,binutils,g -e s,apxs,apache,g|sed -e s,apache\(EAPI\)-devel,apache-devel,g -e s,kernel-headers\(netfilter\),kernel-headers,g -e s,awk,mawk,g -e s,mmawk,mawk,g -e s,motif,openmotif,g -e s,openopenmotif,openmotif,g`"
+                       package_item=$(echo $package_item|sed -e s,rpmbuild,rpm-build,g |sed -e s,__perl,perl,g |sed -e s,gasp,binutils-gasp,g -e s,binutils-binutils,binutils,g -e s,apxs,apache,g|sed -e s,apache\(EAPI\)-devel,apache-devel,g -e s,kernel-headers\(netfilter\),kernel-headers,g -e s,awk,mawk,g -e s,mmawk,mawk,g -e s,motif,openmotif,g -e s,openopenmotif,openmotif,g)
                        GO="yes"
-                       package=`basename "$package_item"|sed -e "s/}$//g"`
-                       COND_ARCH_TST="`cat $SPECFILE|grep -B1 BuildRequires|grep -B1 $package|grep ifarch|sed -e "s/^.*ifarch//g"`"
-                       mach=`uname -m`
+                       package=$(basename "$package_item"|sed -e "s/}$//g")
+                       COND_ARCH_TST=$(cat $SPECFILE|grep -B1 BuildRequires|grep -B1 $package|grep ifarch|sed -e "s/^.*ifarch//g")
+                       mach=$(uname -m)
 
                        COND_TST=`cat $SPECFILE|grep BuildRequires|grep "$package"`
                        if `echo $COND_TST|grep -q '^BuildRequires:'`; then
@@ -1794,7 +1931,7 @@ fetch_build_requires()
                        fi
                done
                if [ "$NOT_INSTALLED_PACKAGES" != "" ]; then
-                       echo "Unable to install following packages and their dependencies:"
+                       echo >&2 "Unable to install following packages and their dependencies:"
                        for pkg in "$NOT_INSTALLED_PACKAGES"
                        do
                                echo $pkg
@@ -1802,30 +1939,72 @@ fetch_build_requires()
                        remove_build_requires
                        exit 8
                fi
-       fi
 }
 
 init_rpm_dir() {
-
-       TOP_DIR="`eval $RPM $RPMOPTS --eval '%{_topdir}'`"
+       TOP_DIR=$(eval $RPM $RPMOPTS --eval '%{_topdir}')
        CVSROOT=":pserver:cvs@$CVS_SERVER:/cvsroot"
 
+       echo "Initialising rpm directories to $TOP_DIR from $CVSROOT"
        mkdir -p $TOP_DIR/{RPMS,BUILD,SRPMS}
        cd $TOP_DIR
-       cvs -d $CVSROOT co SOURCES/.cvsignore SPECS/{mirrors,adapter{,.awk},fetchsrc_request,builder,{relup,compile,repackage}.sh}
+       cvs -d $CVSROOT co SOURCES/{.cvsignore,dropin} SPECS/{mirrors,md5,adapter{,.awk},fetchsrc_request,builder,{relup,compile,repackage}.sh}
 
        init_builder
 
        echo "To checkout *all* .spec files:"
-       echo "- remove $SPECS_DIR/CVS/Entries.Static"
-       echo "- run cvs up in $SPECS_DIR dir"
+       echo "- remove $SPEC_DIR/CVS/Entries.Static"
+       echo "- run cvs up in $SPEC_DIR dir"
 
        echo ""
        echo "To commit with your developer account:"
-       echo "- edit $SPECS_DIR/CVS/Root"
+       echo "- edit $SPEC_DIR/CVS/Root"
        echo "- edit $SOURCE_DIR/CVS/Root"
 }
 
+get_greed_sources() {
+       CVSROOT=":pserver:cvs@$CVS_SERVER:/cvsroot"
+       if [ -n "BE_VERBOSE" ]; then
+               echo "Try greed download: $1 from: $CVSROOT"
+       fi
+       cvs -d $CVSROOT get SOURCES/$1
+       if [ $? != 0 ]; then
+               Exit_error err_no_source_in_repo $1
+       fi
+
+}
+
+# remove entries from CVS/Entries
+cvs_entry_remove() {
+       local cvsdir="$1"; shift
+       if [ ! -d "$cvsdir" ]; then
+               echo >&2 "cvs_entry_remove: $cvsdir is not a directory"
+               exit 1
+       fi
+
+       for file in "$@"; do
+               rm -f $cvsdir/CVS/Entries.new || return 1
+               awk -ve="${file##*/}" -F/ '$2 != e {print}' $cvsdir/CVS/Entries > $cvsdir/CVS/Entries.new || return 1
+               mv -f $cvsdir/CVS/Entries.new $cvsdir/CVS/Entries || return 1
+       done
+       return 0
+}
+
+mr_proper() {
+       init_builder
+       NOCVSSPEC="yes"
+       DONT_PRINT_REVISION="yes"
+       get_spec
+       parse_spec
+
+       # remove from CVS/Entries
+       cvs_entry_remove $SPEC_DIR $SPECFILE
+       cvs_entry_remove $SOURCE_DIR $SOURCES $PATCHES
+
+       # remove spec and sources
+       $RPMBUILD --clean --rmsource --rmspec --nodeps $SPECFILE
+}
+
 #---------------------------------------------
 # main()
 
@@ -1918,6 +2097,9 @@ while [ $# -gt 0 ]; do
                        NOSRCS="yes"
                        ALWAYS_CVSUP="no"
                        shift;;
+               -pm | --prefer-mirrors )
+                       PREFMIRRORS="yes"
+                       shift;;
                --no-init )
                        NOINIT="yes"
                        shift;;
@@ -1925,11 +2107,16 @@ while [ $# -gt 0 ]; do
                        shift; RPMOPTS="${RPMOPTS} ${1}"; shift ;;
                --nopatch | -np )
                        shift; RPMOPTS="${RPMOPTS} --define \"patch${1} : ignoring patch${1}; exit 1; \""; shift ;;
+               --topdir)
+                       RPMOPTS="${RPMOPTS} --define \"_topdir $2\""
+                       shift 2
+                       ;;
                --with | --without )
                        case $GROUP_BCONDS in
                                "yes")
                                        COND=${1}
                                        shift
+                                       # XXX: broken: ./builder -bb ucspi-tcp.spec --without mysql
                                        while ! `echo ${1}|grep -qE '(^-|spec)'`
                                        do
                                                BCOND="$BCOND $COND $1"
@@ -1955,9 +2142,13 @@ while [ $# -gt 0 ]; do
                --date )
                        CVSDATE="${2}"; shift 2 ;;
                -r | --cvstag )
-                       shift; CVSTAG="${1}"; shift ;;
+                       CVSTAG="$2"
+                       shift 2
+                       ;;
                -A)
-                       shift; CVSTAG="HEAD"; ;;
+                       shift
+                       CVSTAG="HEAD"
+                       ;;
                -R | --fetch-build-requires)
                        FETCH_BUILD_REQUIRES="yes"
                        NOT_INSTALLED_PACKAGES=
@@ -2028,6 +2219,9 @@ while [ $# -gt 0 ]; do
                --init-rpm-dir)
                        COMMAND="init_rpm_dir"
                        shift ;;
+               --use-greed-sources )
+                       GREEDSRC="1"
+                       shift;;
                -u | --try-upgrade )
                        TRY_UPGRADE="1"; shift ;;
                -un | --try-upgrade-with-float-version )
@@ -2046,6 +2240,11 @@ while [ $# -gt 0 ]; do
                                RPMOPTS="${RPMOPTS} --define \"${MACRO} ${VALUE}\""
                        fi
                        ;;
+               --alt_kernel)
+                       shift
+                       RPMOPTS="${RPMOPTS} --define \"alt_kernel $1\""
+                       shift
+                       ;;
                --short-circuit)
                        RPMBUILDOPTS="${RPMBUILDOPTS} --short-circuit"
                        shift
@@ -2065,23 +2264,23 @@ while [ $# -gt 0 ]; do
                -debug)
                        RPMBUILDOPTS="${RPMBUILDOPTS} -debug"; shift
                        ;;
-               -* )
+               -*)
                        Exit_error err_invalid_cmdline "$1"
                        ;;
-               * )
+               *)
                        SPECFILE="${1}"
                        # check if specname was passed as specname:cvstag
                        if [ "${SPECFILE##*:}" != "${SPECFILE}" ]; then
                                CVSTAG="${SPECFILE##*:}"
                                SPECFILE="${SPECFILE%%:*}"
                        fi
-                       ASSUMED_NAME="${SPECFILE%%.spec}"
+                       ASSUMED_NAME=$(basename ${SPECFILE%%.spec})
                        shift
        esac
 done
 
 if [ -f CVS/Entries ] && [ -z "$CVSTAG" ]; then
-       CVSTAG=$(awk -vSPECFILE="${SPECFILE%.spec}.spec" -F/ '$2 == SPECFILE && $6 ~ /^T/{print substr($6, 2)}' CVS/Entries)
+       CVSTAG=$(awk -vSPECFILE=$(basename ${SPECFILE%.spec}.spec) -F/ '$2 == SPECFILE && $6 ~ /^T/{print substr($6, 2)}' CVS/Entries)
        if [ "$CVSTAG" ]; then
                echo >&2 "builder: Stick tag $CVSTAG active. Use -r TAGNAME to override."
        fi
@@ -2090,6 +2289,11 @@ elif [ "$CVSTAG" = "HEAD" ]; then
        CVSTAG=""
 fi
 
+if [ "$CVSTAG" ]; then
+       # pass $CVSTAG used by builder to rpmbuild too, so specs could use it
+       RPMOPTS="$RPMOPTS --define \"_cvstag $CVSTAG\""
+fi
+
 if [ -n "$DEBUG" ]; then
        set -x
        set -v
@@ -2151,15 +2355,6 @@ case "$COMMAND" in
 
                        # ./builder -bs test.spec -r AC-branch -Tp auto-ac- -tt
                        if [ -n "$TEST_TAG" ]; then
-                               # - do not allow utf8 encoded specs on AC-branch
-                               if [ "$CVSTAG" = "AC-branch-disabled" ]; then
-                                       local t
-                                       t=$(grep '^Summary(.*\.UTF-8):' $SPECFILE)
-                                       if [ "$t" ]; then
-                                               Exit_error err_acl_deny "UTF-8 .specs not allowed on $CVSTAG"
-                                       fi
-                               fi
-
                                local TAGVER=`make_tagver`
                                echo "Searching for tag $TAGVER..."
                                TAGREL=$(cvs status -v $SPECFILE | grep -E "^[[:space:]]*${TAGVER}[[[:space:]]" | sed -e 's#.*(revision: ##g' -e 's#).*##g')
@@ -2264,7 +2459,7 @@ case "$COMMAND" in
                fi
                ;;
        "mr-proper" )
-               $RPM --clean --rmsource --rmspec --force --nodeps $SPECFILE
+               mr_proper
                ;;
        "list-sources-files" )
                init_builder
This page took 0.144598 seconds and 4 git commands to generate.